import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=0.5] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=0.5] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=0.5] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=0.5] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_middle_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_down", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_down_entity,r=0.5] run summon furnicraft:sit_down_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_down_entity,r=0.5] run summon furnicraft:sit_down_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_down_entity,r=0.5] run summon furnicraft:sit_down_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_down_entity,r=0.5] run summon furnicraft:sit_down_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_down_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_up", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_up_entity,r=0.5] run summon furnicraft:sit_up_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_up_entity,r=0.5] run summon furnicraft:sit_up_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_up_entity,r=0.5] run summon furnicraft:sit_up_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_up_entity,r=0.5] run summon furnicraft:sit_up_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_up_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_park", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_park_entity,r=1] run summon furnicraft:sit_park_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_park_entity,r=1] run summon furnicraft:sit_park_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_park_entity,r=1] run summon furnicraft:sit_park_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_park_entity,r=1] run summon furnicraft:sit_park_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_park_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_wc", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=1] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=1] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=1] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_middle_entity,r=1] run summon furnicraft:sit_middle_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_middle_entity,c=1] teleport_rider`)
            player.runCommand(`playsound mob.pedo.spawn @a[r=6] ~ ~ ~ 1`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bathtub_ride", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_bathtub_entity,r=1] run summon furnicraft:sit_bathtub_entity ~ ~ ~ facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_bathtub_entity,r=1] run summon furnicraft:sit_bathtub_entity ~ ~ ~ facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_bathtub_entity,r=1] run summon furnicraft:sit_bathtub_entity ~ ~ ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:sit_bathtub_entity,r=1] run summon furnicraft:sit_bathtub_entity ~ ~ ~ facing ~-10 ~ ~`)
                    break;
            }

            player.runCommand(`ride @s start_riding @e[type=furnicraft:sit_bathtub_entity,c=1] teleport_rider`)

        },
    });
});