import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_acacia_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:acacia_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_birch_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:birch_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cherry_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cherry_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_dark_oak_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dark_oak_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_jungle_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:jungle_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mangrove_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mangrove_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_oak_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:oak_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_spruce_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:spruce_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_azalea_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:azalea_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_azalea_leaves_flowered", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:azalea_leaves_flowered" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea_leaves_flowered'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_pale_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:pale_oak_leaves" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

///brocha

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_acacia_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_birch_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cherry_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_dark_oak_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_jungle_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mangrove_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_oak_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_spruce_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_azalea_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_azalea_leaves_flowered", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea_leaves_flowered'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_pale_leaves", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_leaves'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//ticking 6,6