import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:chicken", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:chicken" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "chicken"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:chicken_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:chicken", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:porkchop", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:porkchop" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "porkchop"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:porkchop_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:porkchop", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:beef", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:beef" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "beef"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:beef_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:beef", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:mutton", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mutton" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "mutton"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:mutton_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:mutton", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cod", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cod" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cod"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cod_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cod", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:salmon", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:salmon" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "salmon"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:salmon_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:salmon", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:rabbit", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:rabbit" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "rabbit"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:rabbit_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:rabbit", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

///cooked

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_chicken", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_chicken" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_chicken"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_chicken_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_chicken", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_porkchop", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_porkchop" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_porkchop"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_porkchop_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_porkchop", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_beef", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_beef" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_beef"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_beef_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_beef", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_mutton", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_mutton" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_mutton"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_mutton_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_mutton", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_cod", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_cod" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_cod"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_cod_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_cod", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_salmon", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_salmon" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_salmon"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_salmon_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_salmon", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_rabbit", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cooked_rabbit" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "cooked_rabbit"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cooked_rabbit_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cooked_rabbit", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:potato", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:potato" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "potato"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:potato_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:potato", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:baked_potato", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:baked_potato" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_one", {"furnicraft:food": "baked_potato"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:baked_potato_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:baked_potato", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

///more

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dried_kelp", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dried_kelp" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "dried_kelp"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dried_kelp_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:dried_kelp", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:carrot", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:carrot" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "carrot"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:carrot_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:carrot", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:golden_carrot", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:golden_carrot" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "golden_carrot"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:golden_carrot_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:golden_carrot", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:apple", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:apple" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "apple"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:apple_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:apple", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:golden_apple", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:golden_apple" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "golden_apple"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:golden_apple_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:golden_apple", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:melon_slice", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:melon_slice" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "melon_slice"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:melon_slice_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:melon_slice", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:glistering_melon_slice", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:glistering_melon_slice" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "glistering_melon_slice"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:glistering_melon_slice_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:glistering_melon_slice", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cake", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cake" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "cake"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cake_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cake", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:bread", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:bread" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "bread"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:bread_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:bread", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "cookie"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pumpkin_pie", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:pumpkin_pie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "pumpkin_pie"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pumpkin_pie_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:pumpkin_pie", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:glow_berries", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:glow_berries" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "glow_berries"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:glow_berries_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:glow_berries", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:sweet_berries", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:sweet_berries" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "sweet_berries"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:sweet_berries_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:sweet_berries", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:beetroot_soup", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:beetroot_soup" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "beetroot_soup"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:beetroot_soup_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:beetroot_soup", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:rabbit_stew", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:rabbit_stew" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "rabbit_stew"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:rabbit_stew_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:rabbit_stew", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:mushroom_stew", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mushroom_stew" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_two", {"furnicraft:food": "mushroom_stew"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:mushroom_stew_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("minecraft:mushroom_stew", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_three", {"furnicraft:food": "pizza"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:hamburger", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:hamburger_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food_three", {"furnicraft:food": "hamburger"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:hamburger_deleted", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            dimension.spawnItem(new ItemStack("furnicraft:hamburger_item", 1), block.center())
			block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food"))
        },
    });
});
///dishs

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_two", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:plates_with_food" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "two"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_three", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:plates_with_food" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "three"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_four", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:plates_with_food" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "four"}))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_remove_one", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "one"}))
					dimension.spawnItem(new ItemStack("furnicraft:plates_with_food", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_remove_two", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "two"}))
					dimension.spawnItem(new ItemStack("furnicraft:plates_with_food", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:dish_remove_three", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(BlockPermutation.resolve("furnicraft:plates_with_food", {"furnicraft:food": "three"}))
					dimension.spawnItem(new ItemStack("furnicraft:plates_with_food", 1), block.center())
                }
            }
        }
    });
})

///pizza

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_open", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(!player.isSneaking && faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_close", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(!player.isSneaking && faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }
        },
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_one", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","one"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_two", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","two"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_three", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","three"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_four", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","four"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_five", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","five"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_six", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","six"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_seven", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","seven"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_eight", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","eight"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_nine", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "furnicraft:pizza_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","nine"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_zero", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","zero"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_one", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","one"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_two", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","two"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_three", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","three"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_four", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","four"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_five", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","five"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_six", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","six"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_seven", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","seven"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:pizza_remove_eight", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","eight"))
					dimension.spawnItem(new ItemStack("furnicraft:pizza_item", 1), block.center())
                }
            }
        }
    });
})

//cookie_jar


world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_one", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","one"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_two", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","two"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_three", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","three"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_four", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","four"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_five", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","five"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_six", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(!player.isSneaking){
                if(itemStack.typeId == "minecraft:cookie" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","six"))
					dimension.playSound("block.itemframe.rotate_item", block.center())
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//cookie_remove

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_zero_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","zero"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_one_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","one"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_two_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","two"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_three_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","three"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_four_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","four"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:cookie_five_remove", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            if(player.isSneaking){
                if(block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:food","five"))
					dimension.spawnItem(new ItemStack("minecraft:cookie", 1), block.center())
                }
            }
        }
    });
})