import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glass", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("glass_panel") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("glass_panel") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("glass_panel") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("glass_panel") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("glass_panel") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("glass_panel") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("glass_panel") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("glass_panel") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glass_colors_place", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_one`)
                    break;
                case 'south':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_one`)
                    break;
                case 'east':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_two`)
                    break;
                case 'west':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_two`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glass_colors_place_two", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_three`)
                    break;
                case 'south':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_three`)
                    break;
                case 'east':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_three`)
                    break;
                case 'west':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_colors_three`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glass_place", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_one`)
                    break;
                case 'south':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_one`)
                    break;
                case 'east':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_two`)
                    break;
                case 'west':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_two`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glass_place_two", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_three`)
                    break;
                case 'south':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_three`)
                    break;
                case 'east':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_three`)
                    break;
                case 'west':
                    chairEntity.runCommand(`setblock ~ ~ ~ furnicraft:glass_panel_three`)
                    break;
            }

        },
    });
});