import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:open", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:close", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:close_auto", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_denied", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item"){
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`function denied_brocha`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:animation_off", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute unless entity @a[r=1] run playanimation @a[r=3] animation.humanoid.dance_reset`)
                    chairEntity.runCommand(`execute unless entity @a[r=1] run camera @a[r=5] clear`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute unless entity @a[r=1] run playanimation @a[r=3] animation.humanoid.dance_reset`)
                    chairEntity.runCommand(`execute unless entity @a[r=1] run camera @a[r=5] clear`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute unless entity @a[r=1] run playanimation @a[r=3] animation.humanoid.dance_reset`)
                    chairEntity.runCommand(`execute unless entity @a[r=1] run camera @a[r=5] clear`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute unless entity @a[r=1] run playanimation @a[r=3] animation.humanoid.dance_reset`)
                    chairEntity.runCommand(`execute unless entity @a[r=1] run camera @a[r=5] clear`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:paper_close", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:paper"){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    if(itemStack.amount != 1){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-1))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:paper_open", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");
            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    chairEntity.runCommand(`loot spawn ~ ~ ~ loot fpaper`)
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    chairEntity.runCommand(`loot spawn ~ ~ ~ loot fpaper`)
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    chairEntity.runCommand(`loot spawn ~ ~ ~ loot fpaper`)
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    chairEntity.runCommand(`loot spawn ~ ~ ~ loot fpaper`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:watering_can_water", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    dimension.spawnParticle("furnicraft:water_particle",{ x: blockCenter.x - 0.1, y: blockCenter.y - 0.0, z: blockCenter.z - 0.1 });
                    break;
                case 'south':
                    dimension.spawnParticle("furnicraft:water_particle",{ x: blockCenter.x - 0.1, y: blockCenter.y - 0.0, z: blockCenter.z - 0.1 });
                    break;
                case 'east':
                    dimension.spawnParticle("furnicraft:water_particle",{ x: blockCenter.x - 0.1, y: blockCenter.y - 0.0, z: blockCenter.z - 0.1 });
                    break;
                case 'west':
                    dimension.spawnParticle("furnicraft:water_particle",{ x: blockCenter.x - 0.1, y: blockCenter.y - 0.0, z: blockCenter.z - 0.1 });
                    break;
            }
        },
    });
});

//ticking 6,6