import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'south':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'east':
                    chairEntity.runCommand(`function lightson`)
                    break;
                case 'west':
                    chairEntity.runCommand(`function lightson`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'south':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'east':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
                case 'west':
                    chairEntity.runCommand(`function lightsoff`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fan_on_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fan_off_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fan_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","four"))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","four"))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","four"))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","four"))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fan_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fan_one", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","one"))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fan_two", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","two"))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","two"))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","two"))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","two"))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fan_three", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","three"))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","three"))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","three"))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:fan","three"))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_on", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:lights_three,r=1] run summon furnicraft:lights_three ~ ~-0.5 ~-0.4 facing ~ ~ ~-10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:lights_three,r=1] run summon furnicraft:lights_three ~ ~-0.5 ~0.4 facing ~ ~ ~10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:lights_three,r=1] run summon furnicraft:lights_three ~0.4 ~-0.5 ~ facing ~10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:lights_three,r=1] run summon furnicraft:lights_three ~-0.4 ~-0.5 ~ facing ~-10 ~ ~`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_blue", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_blue`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_blue`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_blue`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_blue`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_green", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_green`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_green`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_green`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_green`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_red", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_red`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_red`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_red`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_red`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_purple", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_purple`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_purple`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_purple`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_purple`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_off`)
                    break;
                case 'south':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_off`)
                    break;
                case 'east':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_off`)
                    break;
                case 'west':
                    chairEntity.runCommand(`event entity @e[type=furnicraft:lights_three,r=64] furnicraft:lights_off`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_animation_one", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_one animation.lights_concerts_one`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_one animation.lights_concerts_one`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_one animation.lights_concerts_one`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_one animation.lights_concerts_one`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_animation_two", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_two animation.lights_concerts_two`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_two animation.lights_concerts_two`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_two animation.lights_concerts_two`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_two animation.lights_concerts_two`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_animation_three", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_three animation.lights_concerts_three`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_three animation.lights_concerts_three`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_three animation.lights_concerts_three`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_three animation.lights_concerts_three`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_animation_four", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_four animation.lights_concerts_four`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_four animation.lights_concerts_four`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_four animation.lights_concerts_four`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_four animation.lights_concerts_four`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:lights_concerts_animation_five", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_five animation.lights_concerts_five`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_five animation.lights_concerts_five`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_five animation.lights_concerts_five`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playanimation @e[type=furnicraft:lights_three,r=64] animation.lights_concerts_five animation.lights_concerts_five`)
                    break;
            }

        },
    });
});