import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_acacia_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:acacia_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_birch_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:birch_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cherry_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cherry_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_dark_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dark_oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_jungle_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:jungle_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mangrove_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mangrove_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_spruce_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:spruce_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_crimson_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:crimson_stem" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crimson_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_warped_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:warped_stem" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_bomboo_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:bamboo_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bomboo_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_pale_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:pale_oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//stripped

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_acacia_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_acacia_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_acacia_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_birch_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_birch_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_birch_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_cherry_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_cherry_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_cherry_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_dark_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_dark_oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_dark_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_jungle_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_jungle_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_jungle_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_mangrove_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_mangrove_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_mangrove_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_spruce_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_spruce_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_spruce_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_crimson_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_crimson_stem" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_crimson_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_warped_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_warped_stem" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_warped_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_bomboo_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_bamboo_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_bomboo_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stripped_pale_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stripped_pale_oak_log" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_pale_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

///planks

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_acacia_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:acacia_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_birch_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:birch_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cherry_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cherry_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_dark_oak_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dark_oak_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_jungle_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:jungle_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mangrove_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mangrove_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_oak_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:oak_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_spruce_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:spruce_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_crimson_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:crimson_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crimson_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_warped_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:warped_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_bamboo_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:bamboo_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bamboo_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_bamboo_mosaic_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:bamboo_mosaic" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bamboo_mosaic_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_pale_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:pale_oak_planks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//stones

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cobblestone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cobblestone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobblestone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cobblestone_mossy", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mossy_cobblestone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobblestone_mossy'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_granite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:granite" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'granite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_diorite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:diorite" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'diorite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_andesite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:andesite" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'andesite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_blackstone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:blackstone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'blackstone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_prismarine", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:prismarine" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'prismarine'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_deepslate", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:deepslate" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cobbled_deepslate", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cobbled_deepslate" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobbled_deepslate'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_tuff", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:tuff" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'tuff'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//bricks

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:stone_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mossy_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mossy_stone_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mossy_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_cracked_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:cracked_stone_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cracked_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_chiseled_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:chiseled_stone_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_deepslate_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:deepslate_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_deepslate_tiles", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:deepslate_tiles" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate_tiles'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_polished_blackstone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:polished_blackstone_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'polished_blackstone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_brick_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:brick_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'brick_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_quartz_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:quartz_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'quartz_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_prismarine_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:prismarine_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'prismarine_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_dark_prismarine", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dark_prismarine" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_prismarine'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_tuff_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:tuff_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'tuff_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_resin_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:resin_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'resin_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_chiseled_resin_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:chiseled_resin_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_resin_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//ores

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_iron_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:iron_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'iron_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_copper_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:copper_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'copper_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_gold_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:gold_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'gold_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_lapis_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:lapis_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'lapis_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_emerald_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:emerald_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'emerald_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_diamond_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:diamond_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'diamond_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_netherite_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:netherite_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'netherite_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_amethyst_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:amethyst_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'amethyst_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_redstone_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:redstone_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'redstone_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_coal_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:coal_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'coal_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_quartz_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:quartz_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'quartz_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_chiseled_quartz_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:chiseled_quartz_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_quartz_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_chiseled_quartz_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:chiseled_quartz_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_quartz_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_resin_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:resin_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'resin_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//nether

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_netherrack", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:netherrack" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'netherrack'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_nether_brick", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:nether_brick" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'nether_brick'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_red_nether_brick", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:red_nether_brick" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'red_nether_brick'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_soul_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:soul_sand" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'soul_sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_soul_soil", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:soul_soil" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'soul_soil'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_nether_wart_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:nether_wart_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'nether_wart_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_warped_wart_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:warped_wart_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_wart_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_obsidian", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:obsidian" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'obsidian'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_crying_obsidian", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:crying_obsidian" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crying_obsidian'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_magma", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:magma" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'magma'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_shroomlight", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:shroomlight" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'shroomlight'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_glowstone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:glowstone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'glowstone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//end

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_end_stone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:end_stone" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'end_stone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_end_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:end_bricks" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'end_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_purpur_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:purpur_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'purpur_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_purpur_pillar", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:purpur_pillar" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'purpur_pillar'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_ender_chest", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:ender_chest" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'ender_chest'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//nature

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_dirt", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:dirt" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dirt'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_grass_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:grass_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'grass_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_podzol", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:podzol" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'podzol'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mycelium", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mycelium" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mycelium'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_moss_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:moss_block" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'moss_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_snow", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:snow" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'snow'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:sand" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_red_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:red_sand" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'red_sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_clay", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:clay" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'clay'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_mud", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:mud" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mud'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_azalea", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:azalea" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:material_flowering_azalea", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:flowering_azalea" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'flowering_azalea'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//ticking 6,6