import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_acacia_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_birch_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cherry_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_dark_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_jungle_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mangrove_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_spruce_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_crimson_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crimson_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_warped_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_bomboo_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bomboo_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_pale_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//stripped

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_acacia_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_acacia_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_birch_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_birch_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_cherry_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_cherry_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_dark_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_dark_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_jungle_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_jungle_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_mangrove_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_mangrove_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_oak_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_oak_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_spruce_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_spruce_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_crimson_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_crimson_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_warped_stem", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_warped_stem'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_bomboo_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_bomboo_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stripped_pale_log", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stripped_pale_log'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

///planks

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_acacia_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'acacia_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_birch_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'birch_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cherry_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cherry_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_dark_oak_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_oak_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_jungle_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'jungle_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mangrove_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mangrove_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_oak_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'oak_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_spruce_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'spruce_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_crimson_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crimson_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_warped_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_bamboo_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bamboo_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_bamboo_mosaic_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'bamboo_mosaic_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_pale_planks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'pale_planks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//stones

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cobblestone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobblestone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cobblestone_mossy", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobblestone_mossy'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_granite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'granite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_diorite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'diorite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_andesite", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'andesite'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_blackstone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'blackstone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_prismarine", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'prismarine'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_deepslate", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cobbled_deepslate", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cobbled_deepslate'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_tuff", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'tuff'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//bricks

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mossy_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mossy_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_cracked_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'cracked_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_chiseled_stone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_stone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_deepslate_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_deepslate_tiles", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'deepslate_tiles'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_polished_blackstone_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'polished_blackstone_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_brick_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'brick_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_quartz_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'quartz_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_prismarine_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'prismarine_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_dark_prismarine", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dark_prismarine'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_tuff_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'tuff_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_resin_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'resin_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_chiseled_resin_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_resin_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//ores

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_iron_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'iron_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_copper_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'copper_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_gold_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'gold_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_lapis_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'lapis_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_emerald_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'emerald_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_diamond_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'diamond_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_netherite_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'netherite_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_amethyst_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'amethyst_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_redstone_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'redstone_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_coal_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'coal_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_quartz_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'quartz_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_chiseled_quartz_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'chiseled_quartz_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_resin_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'resin_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//nether

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_netherrack", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'netherrack'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_nether_brick", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'nether_brick'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_red_nether_brick", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'red_nether_brick'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_soul_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'soul_sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_soul_soil", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'soul_soil'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_nether_wart_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'nether_wart_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_warped_wart_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'warped_wart_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_obsidian", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'obsidian'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_crying_obsidian", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'crying_obsidian'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_magma", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'magma'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_shroomlight", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'shroomlight'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_glowstone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'glowstone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//end

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_end_stone", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'end_stone'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_end_bricks", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'end_bricks'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_purpur_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'purpur_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_purpur_pillar", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'purpur_pillar'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_ender_chest", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'ender_chest'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

//nature

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_dirt", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'dirt'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_grass_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'grass_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_podzol", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'podzol'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mycelium", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mycelium'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_moss_block", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'moss_block'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_snow", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'snow'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_red_sand", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'red_sand'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_clay", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'clay'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_mud", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'mud'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_azalea", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'azalea'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:brocha_flowering_azalea", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "furnicraft:brocha_item" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:materials",'flowering_azalea'))
                    furniEntity.runCommand(`playsound fall.amethyst_block @a[r=10] ~ ~ ~ 1 1`)
					furniEntity.runCommand(`particle furnicraft:place_particle ~~1~`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})


//ticking 6,6