import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:piano_sound", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound mob.piano.spawn @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound mob.piano.spawn @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound mob.piano.spawn @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound mob.piano.spawn @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:iseethelights_sound", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:diamond" && block.permutation.getState("minecraft:cardinal_direction")){
                    furniEntity.runCommand(`stopsound @a[r=20]`)
                    furniEntity.runCommand(`playsound iseethelights.song @a[r=20] ~ ~ ~ 1`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:stop_sound", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:glass" && block.permutation.getState("minecraft:cardinal_direction")){
                    furniEntity.runCommand(`stopsound @a[r=20]`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})


world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_place", {
        onPlace: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`structure load mystructure:drummer_south ~-1~~-1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`structure load mystructure:drummer_north ~-1~~-1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`structure load mystructure:drummer_west ~-1~~-1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`structure load mystructure:drummer_east ~-1~~-1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_bombo", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound bombo.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound bombo.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound bombo.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound bombo.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_toms", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound toms.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound toms.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound toms.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound toms.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_bomb_left", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound bomb1.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound bomb1.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound bomb1.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound bomb1.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_bomb_right", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound bomb2.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound bomb2.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound bomb2.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound bomb2.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_crash_left", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound crashl.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound crashl.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound crashl.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound crashl.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_crash_middle", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound crashm.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound crashm.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound crashm.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound crashm.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bateria_sound_crash_right", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound crashr.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound crashr.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound crashr.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound crashr.bateria.on @a[r=10] ~ ~ ~ 1`)
                    break;
            }

        },
    });
});