import { EquipmentSlot, ItemStack, world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:click_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound interuptor.on @a[r=6] ~ ~ ~ 0.2`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:click_off", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound interuptor.off @a[r=6] ~ ~ ~ 0.2`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fire_sound", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=10] ~ ~ ~ 0.5`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=10] ~ ~ ~ 0.5`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=10] ~ ~ ~ 0.5`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound block.campfire.crackle @a[r=10] ~ ~ ~ 0.5`)
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:fire_off", {
        onPlayerInteract(event){
            const {block, player, dimension} = event
            const blockCenter = block.center();
            const furniEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })
            const itemStack = player.getComponent("equippable").getEquipment(EquipmentSlot.Mainhand)
            if(itemStack){
                if(itemStack.typeId == "minecraft:flint_and_steel" && block.permutation.getState("minecraft:cardinal_direction")){
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    furniEntity.runCommand(`playsound fire.ignite @a[r=10] ~ ~ ~ 0.5`)
                    furniEntity.runCommand(`playsound block.campfire.crackle @a[r=10] ~ ~ ~ 0.5`)
                    if(itemStack.amount != 0){
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, new ItemStack(itemStack.typeId, itemStack.amount-0))
                    }else{
                        player.getComponent("equippable").setEquipment(EquipmentSlot.Mainhand, undefined)
                    }
                }
            }
        }
    });
})

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:fire_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound random.fizz @a[r=6] ~ ~ ~ 0.5`)
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:keyboard", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`playsound keyboard.on @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'south':
                    chairEntity.runCommand(`playsound keyboard.on @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'east':
                    chairEntity.runCommand(`playsound keyboard.on @a[r=6] ~ ~ ~ 0.5`)
                    break;
                case 'west':
                    chairEntity.runCommand(`playsound keyboard.on @a[r=6] ~ ~ ~ 0.5`)
                    break;
            }

        },
    });
});