import { world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:swings_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:swings_desactivate", {
        onTick: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    break;
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_swings", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:columpio_entity,r=1] run summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~ ~ ~10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:columpio_entity,r=1] run summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~ ~ ~-10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:columpio_entity,r=1] run summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~-10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute positioned ~ ~ ~ unless entity @e[type=furnicraft:columpio_entity,r=1] run summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~10 ~ ~`)
                    break;
            }
            player.runCommand(`ride @s start_riding @e[type=furnicraft:columpio_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:swings_activate", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            player.runCommand(`execute positioned ~ ~ ~ at @e[type=furnicraft:columpio_entity,r=1] run playanimation @e[family=slide,r=2] animation.columpio_entity.on`)
            player.runCommand(`execute positioned ~ ~ ~ at @e[type=furnicraft:columpio_entity,r=1] run playanimation @a[r=1] animation.columpio_entity.on`)

        },
    });
});

//ticking 6,6