import { world, system } from "@minecraft/server";

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('furnicraft:durability', {
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function test"); },
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
 
world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('furnicraft:emotes', {
  
onUse({ source }) {
    source.runCommand("execute positioned as @s[hasitem={location=slot.weapon.mainhand,item=furnicraft:emotes_item},m=survival] unless entity @e[type=furnicraft:emotes_entity,r=1] positioned ~~~ run summon furnicraft:emotes_entity ~~~")
    source.runCommand("execute if entity @s[m=survival] positioned ~~~ run playsound note.bell @s[hasitem={location=slot.weapon.mainhand,item=furnicraft:emotes_item}]")
    source.runCommand("execute if entity @s[m=survival] positioned ~~~ run dialogue open @e[type=furnicraft:emotes_entity,r=1] @s[hasitem={location=slot.weapon.mainhand,item=furnicraft:emotes_item}] emotes1_menu")
    source.runCommand("function emotesoff")
}
});
 });
 
world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('furnicraft:katanna', {
  
onUse({ source }) {
    source.runCommand("summon furnicraft:katana_spawn ~~~")
    source.runCommand("playanimation @s[tag=EmoteNormal] animation.humanoid.custom_katana_normal")
    source.runCommand("playanimation @s[tag=EmoteBaby] animation.humanoid.custom_katana_baby")
    source.runCommand("playanimation @s[tag=EmoteGigant] animation.humanoid.custom_katana_gigant")
    source.runCommand("playanimation @s[tag=EmotePaper] animation.humanoid.custom_katana_paper")
}
});
 });
 
 world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('furnicraft:stormbraker', {
  
onUse({ source }) {
    source.runCommand("playanimation @s[tag=EmoteNormal] animation.humanoid.custom_stormbraker_normal")
    source.runCommand("playanimation @s[tag=EmoteBaby] animation.humanoid.custom_stormbraker_baby")
    source.runCommand("playanimation @s[tag=EmoteGigant] animation.humanoid.custom_stormbraker_gigant")
    source.runCommand("playanimation @s[tag=EmotePaper] animation.humanoid.custom_stormbraker_paper")
    source.runCommand("summon lightning_bolt ^^^5")
}
});
 });
 
 world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('furnicraft:meguminstaff', {
  
onUse({ source }) {
    source.runCommand("playanimation @s[tag=EmoteNormal] animation.humanoid.custom_stormbraker_normal")
    source.runCommand("playanimation @s[tag=EmoteBaby] animation.humanoid.custom_stormbraker_baby")
    source.runCommand("playanimation @s[tag=EmoteGigant] animation.humanoid.custom_stormbraker_gigant")
    source.runCommand("playanimation @s[tag=EmotePaper] animation.humanoid.custom_stormbraker_paper")
    source.runCommand("event entity @e[type=sheep,r=10] wololo")
	source.runCommand("effect @e[type=creeper,r=10] levitation 1 30 false")
    source.runCommand("replaceitem entity @e[type=zombie,c=1,r=10] slot.weapon.offhand 0 furnicraft:yandere_one_cosplay")
    source.runCommand("replaceitem entity @e[type=skeleton,c=1,r=10] slot.weapon.offhand 0 furnicraft:yandere_three_cosplay")
    source.runCommand("xp -1L @s ")
    source.runCommand("playsound mob.evocation_illager.cast_spell @a[r=10]")
    source.runCommand("tag @s add EmotePlay")
}
});
 });